function trmsim=gr_term_sim1(GO,terms,tidbp)
% calcultes term similarity based on the common ancestors and common
% descendents
%
% GO - gene ontology object
% terms - terms which should be analysed (GO term identifiers)
% tidbp - terms belonging to biological process ontology (see below)

% find terms belonging to biological process ontology (tidbp)
% [n1,n2]=size(GO.Terms);
% a=zeros(1,n1);
% for i=1:n1
%     if GO.Terms(i).ontology=='biological process'
%         tidbp(i)=GO.Terms(i).id;
%         a(i)=1;
%     end;
% end;
% save('tidbp.mat','tidbp');



trmsim=ones(numel(terms),numel(terms));
trmi=zeros(1,numel(tidbp));
trmj=zeros(1,numel(tidbp));

for i=1:numel(terms)-1
    fprintf('%d ',i);
    if floor(i/100)*100==i,
        fprintf('\n');
    end;
    
    anc=getancestors(GO,terms(i));
    des=getdescendants(GO,terms(i));
    for j=1:numel(anc)
        x=(tidbp==anc(j));
        trmi=trmi+x;
    end;
    for j=1:numel(des)
        y=(tidbp==des(j));
        trmi=trmi+y;
    end;    
    for ij=i+1:numel(terms)
        anc=getancestors(GO,terms(ij));
        des=getdescendants(GO,terms(ij));
        for j=1:numel(anc)
            x=(tidbp==anc(j));
            trmj=trmj+x;
        end;
        for j=1:numel(des)
            y=(tidbp==des(j));
            trmj=trmj+y;
        end;    
        
        a=sum(and(trmi,trmj));
        b=sum(or(trmi,trmj));
        trmsim(i,ij)=a/b;
        trmsim(ij,i)=trmsim(i,ij);
    end;
    
    
end;

