function trmsim=grsoft_term_sim2(GO,terms)
% calcultes term similarity based on the common ancestors and common
% descendents
%
% GO - gene ontology object
% terms - terms which should be analysed (GO term identifiers)


trmsim=ones(numel(terms),numel(terms));

for i=1:numel(terms)-1
    fprintf('%d ',i);
    if floor(i/100)*100==i,
        fprintf('\n');
    end;
    
    % find all the ancestors and descendants of term i
    trmis=pth(GO,terms(i));
    
    % find all the ancestors and descendants of term ij    
    for ij=i+1:numel(terms)
        trmjs=pth(GO,terms(ij));
        a=sum(min(trmis,trmjs));
        b=sum(max(trmis,trmjs));
        trmsim(i,ij)=a/b;
        trmsim(ij,i)=trmsim(i,ij);
    end;
   
end;


